SystemOrganization addCategory: #'CS528-SkeetManager'!

WAFileLibrary subclass: #MyFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Error subclass: #ScoreFormatError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Error subclass: #ShooterNotFoundError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

WAComponent subclass: #ViewAddCompositeEvent
	instanceVariableNames: 'compositeEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewAddCompositeEvent class methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/29/2013 18:41'!
newWithCompositeEvent: aCompositeEvent
	^self new compositeEvent: aCompositeEvent.! !

!ViewAddCompositeEvent methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/23/2013 17:27'!
compositeEvent
    ^compositeEvent.! !

!ViewAddCompositeEvent methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/23/2013 17:28'!
compositeEvent: anCompositeEvent
     compositeEvent := anCompositeEvent.! !

!ViewAddCompositeEvent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 19:29'!
renderContentOn: html
	| allEvents aShoot |
	html break.
	compositeEvent
		ifNil: [ 
			compositeEvent := CompositeEvent newEventWithName: 'No Name'.
			compositeEvent shoot: self shoot ].
	html
		form: [ 
			html text: 'Composite Event Name '.
			html textInput
				value: compositeEvent name;
				callback: [ :value | compositeEvent name: value ].
			html break.
			html heading: 'Select Events:' level: 5.
			aShoot := compositeEvent shoot.
			allEvents := aShoot events.
			allEvents := allEvents select: [ :eachEvent | eachEvent class = Event ].
			allEvents size > 0
				ifTrue: [ 
					allEvents
						do: [ :each | 
							html checkbox
								value: (compositeEvent events includes: each);
								callback: [ :value | 
											value
												ifTrue: [ compositeEvent addEvent: each ]
												ifFalse: [ 
													(compositeEvent events includes: each)
														ifTrue: [ compositeEvent remove: each ] ] ].
							html text: each name.
							html break ] ]
				ifFalse: [ html text: 'no events to select' ].
			html break.	"lz"
			html break.	"lz"
			html submitButton
				callback: [ self answer: compositeEvent ];
				text: 'Save' ]	"html cancelButton
            callback: [ self answer: nil ];
            text: 'Cancel' ]"! !

!ViewAddCompositeEvent methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/24/2013 13:48'!
shooter
	^ shooter.! !

!ViewAddCompositeEvent methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/24/2013 13:49'!
shooter: aShooter
	shooter := aShooter.
		! !

WAComponent subclass: #ViewAddEvent
	instanceVariableNames: 'event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewAddEvent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:17'!
newWithEvent: anEvent
	^self new event: anEvent.! !

!ViewAddEvent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 13:09'!
event
	^ event.! !

!ViewAddEvent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:21'!
event: anEvent
	event := anEvent.! !

!ViewAddEvent methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/29/2013 18:17'!
renderContentOn: html
	
	html break.
	
	event ifNil: [event := (Event newEventWithName: 'No Name'). event shoot: self shoot.]. 
	
	html form: [
        html text: 'Event Name'.
        html textInput
            value: event name;
            callback: [ :value | event name: value ].
        html break.
	
	html text: 'Type '.
        html select 
            list: EventType allSubclasses ;
            selected: (event eventType) class;
            callback: [ :value |
                event eventType: (value new) ].
        html break.

	 html submitButton
            callback: [ self answer: event ];
            text: 'Save'.].
        "html cancelButton
            callback: [ self answer: nil ];
            text: 'Cancel' ]"
		! !

WAComponent subclass: #ViewAddShoot
	instanceVariableNames: 'shoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewAddShoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/22/2013 22:36'!
renderContentOn: html
	
	html break.
	
	html form: [
        html text: 'Shoot Name'.
        html textInput
            value: 'No Name';
            callback: [ :value | shoot := (Shoot newShootWithName: value) ].
        html break.
        html submitButton
            callback: [ self answer: shoot ];
            text: 'Save'.
        html cancelButton
            callback: [ self answer: nil ];
            text: 'Cancel' ]
		 ! !

!ViewAddShoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 12:59'!
shoot
	^ shoot.
		! !

WAComponent subclass: #ViewAddShooter
	instanceVariableNames: 'shooter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewAddShooter class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:52'!
newWithShooter: aShooter 
	^self new shooter: aShooter.! !

!ViewAddShooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/22/2013 22:36'!
renderContentOn: html
	
	|allTypes allConcurrents allEvents |
	html break.
	 
	html form: [
        html text: 'First Name: ' .
        html textInput
            value: shooter firstName;
            callback: [ :value | shooter firstName: value ].
        html break.

	html text: 'Middle Name'.
        html textInput
            value: shooter middleName;
            callback: [ :value | shooter middleName: value].
	html break.
	
	html text: 'Last Name'.
        html textInput
            value: shooter lastName;
            callback: [ :value | shooter lastName: value].
	html break.
	
	 html text: 'Date of Birth'.
        html dateInput
		value: shooter dob;
       	 callback: [ :value | shooter dob: value ].
       html break.  

      html text: 'Membership Number'.
        html textInput
            value: shooter membershipNumber;
            callback: [ :value | shooter membershipNumber: value].
	html break.

	html text: 'Address'.
        html textInput
            value: shooter address ;
            callback: [ :value | shooter address: value].
	html break.
	
	html text: 'Phone'.
        html textInput
            value: shooter phone;
            callback: [ :value | shooter phone: value].
	html break.
	
      html text: 'Email'.
        html textInput
            value: shooter email;
            callback: [ :value | shooter email: value ].
	html break.
	
	allTypes := EventType allSubclasses.
	allTypes := allTypes collect: [:each | each new ].
	
	html break.
	html text: 'Classifications '.
	html break.
		allTypes do: [ :type|
			html text: type name.
			html space. 
			html select 
            		list: ClassType allSubclasses ;   
				selected: ((shooter classFor: type) class);        
            		callback: [ :value |
                			shooter setClass: (value new) forEvent: type  ].
			html space.
			html textInput
            		value: (shooter averageFor: type);
            		callback: [ :value | shooter setAverage: (value asNumber) forEvent: type].
			
			 ] separatedBy:[ html break.].
			
       
        html break.
	html break.
	 html text: 'Concurrents: '.
	html break.
 	allConcurrents := ConcurrentType allSubclasses.
	allConcurrents := allConcurrents collect: [ :each| each new ].
	
	allConcurrents do: [ :each |
		html checkbox
            value:  (shooter belongsToConcurrent: each) ;
            callback: [ :value | value ifTrue: [ shooter addConcurrent: each] ] .
		html text: (each class).
		html break.
		].
        html break.


	 html break.
	html break.
	 html text: 'Select Events '.
	html break.
 	allEvents := shooter shoot events.
	
	allEvents do: [ :each |
		html checkbox
            value:  (shooter enteredEvent: each) ;
            callback: [ :value | value ifTrue: [ each addShooter: shooter] ] .
		html text: (each name).
		html break.
		].
        html break.
		 
	"
        
	
  

	
    html text: 'Date of Birth'.
        html textInput
            value: 'No Name';
            callback: [ :value | shooter dob: value].
	html break.
  
    html text: 'Membership Number'.
        html textInput
            value: 'No Name';
            callback: [ :value | shooter membershipNumber: value].
	html break.

    html text: 'Classification'.
        html textInput
            value: 'No Name';
            callback: [ :value | shooter  classFor: value].
	html break.

      html text: 'Averages'.
        html textInput
            value: 'No Name';
            callback: [ :value | shooter  averageFor: value].
	html break.
	
        html text: 'concurrents'.
        html textInput
            value: 'No Name';
            callback: [ :value | shooter  concurrents ].
	html break.
	  "
        html submitButton
            callback: [ self answer: shooter ];
            text: 'Save'.].
        "html cancelButton
            callback: [ self answer: nil ];
            text: 'Cancel'  .]."
		! !

!ViewAddShooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 14:20'!
shooter
	^ shooter.
		! !

!ViewAddShooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:53'!
shooter: aShooter
	shooter := aShooter.
		! !

WAComponent subclass: #ViewEvent
	instanceVariableNames: 'shoot event rightView leftView showEventScoresView showEventRankingsView showEventShootoffsView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewEvent methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/23/2013 17:45'!
addCompositeEvent
	
	rightView := ViewAddCompositeEvent new.
	rightView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot addEvent:  ( rightView compositeEvent ). 
				shoot save.
				
				].
		rightView := nil.
	]! !

!ViewEvent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/23/2013 00:24'!
addEvent
	
	rightView := ViewAddEvent new.
	rightView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot addEvent:  ( rightView event ). 
				shoot save.
				
				].
		rightView := nil.
	]! !

!ViewEvent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/23/2013 00:24'!
addShooter
	
	rightView := ViewAddShooter new.
	rightView shooter: (Shooter newShooterFirstName: 'No Name' shoot: shoot).
	rightView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot addShooter:  ( rightView shooter ). 
				shoot save.
				].
		rightView := nil.
		 ]! !

!ViewEvent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/23/2013 00:24'!
children 
	^ {addEventView . addShooterView . showShootersView . showEventsView} asArray.! !

!ViewEvent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/23/2013 00:24'!
hide
	
	leftView := nil.! !

!ViewEvent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/23/2013 00:24'!
hideRight
	
	rightView := nil.! !

!ViewEvent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 19:56'!
renderContentOn: html
	html div
		class: 'container';
		with: [ 
					html anchor
						class: 'label';
						callback: [ ViewEvent new shoot: shoot event: event ];
						with: 'Event Name: ' , event name.
					html break.
					html break.
					html div
						class: 'row';
						with: [ 
									html div
										class: 'span7';
										with: [ 
													html anchor
														class: 'btn-small btn-warning';
														callback: [ self showScores: event ];
														with: 'Show Scores'.
													html space.
													html anchor
														class: 'btn-small btn-warning';
														callback: [ self showRankings: event ];
														with: 'Show Rankings'.
													html space.
													html anchor
														class: 'btn-small btn-warning';
														callback: [ self showShootoffs: event ];
														with: 'Show Shootoffs'.
													html space.
													html anchor
														class: 'btn-small btn-warning';
														callback: [ self showResolveShootoffs: event ];
														with: 'Resolve Shootoffs'.	"html space.
	html anchor 
		class:'btn btn-warning';	
        callback: [ self showWinners: event ];
        with: 'Show Winners'."
													html space.
													html anchor
														class: 'btn-small btn-warning';
														callback: [ self hide ];
														with: 'Hide'.
													html break.
													html break.
													html render: leftView ].
									html div
										class: 'span5';
										with: [ 
													"html anchor 
		class:'btn btn-info';
        callback: [ self addEvent ];
        with: 'Add New Event'.
	
	html space. 
	html anchor 
		class:'btn btn-info';	
        callback: [ self addShooter ];
        with: 'Add New Shooter'.

	html space. 
	html anchor 
		class:'btn btn-info';	
        callback: [ self hideRight ];
        with: 'Hide'."
													html break.
													html break.
													html render: rightView ] ] ]! !

!ViewEvent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/23/2013 00:24'!
shoot
	^ shoot.! !

!ViewEvent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/23/2013 00:24'!
shoot: aShoot
	shoot := aShoot.! !

!ViewEvent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/23/2013 10:52'!
shoot: aShoot event: anEvent
	shoot := aShoot.
	event := anEvent.! !

!ViewEvent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/23/2013 00:24'!
showEvents
	
	leftView := ViewShowEvents newWithShoot: shoot.
	leftView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
			
				rightView := value. 
				shoot save.
			] .
		
	]! !

!ViewEvent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/30/2013 00:27'!
showRankings: anEvent
	"Update honors"

	leftView := ViewShowEventRankings newWithShoot: shoot andEvent: anEvent.
	anEvent shootoffs size > 0
		ifTrue: [ 
			(anEvent shootoffsAnySatisfy: [ :eachShootoff | eachShootoff isResolved ])
				ifFalse: [ 
					anEvent createHonors.
					anEvent generateHonors ] ]
		ifFalse: [ anEvent createHonors ].
	leftView
		onAnswer: [ :value | 
			value isNil
				ifFalse: [ shoot save ].
			leftView := nil ]! !

!ViewEvent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 15:22'!
showResolveShootoffs: anEvent
	
	leftView := ViewShowResolveEventShootoffs newWithShoot: shoot andEvent: anEvent.

	leftView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot save. 
			].
		 ]! !

!ViewEvent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/23/2013 11:11'!
showScores: anEvent
	leftView := ViewShowEventScores newWithShoot: shoot andEvent: anEvent.

	leftView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot save. 
			].
			
		 ]! !

!ViewEvent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/23/2013 00:24'!
showShooters
	
	leftView := ViewShowShooters newWithShoot: shoot.
	leftView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				rightView := value. 
				shoot save.
			] .
		
	]! !

!ViewEvent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 19:39'!
showShootoffs: anEvent
	"Update honors and shootoffs"

	anEvent shootoffs size > 0
		ifTrue: [ 
			(anEvent shootoffsAnySatisfy: [ :eachShootoff | eachShootoff isResolved ])
				ifFalse: [ 
					anEvent createHonors.
					anEvent generateHonors ] ]
		ifFalse: [ 
			anEvent createHonors.
			anEvent generateHonors ].
	leftView := ViewShowEventShootoffs newWithShoot: shoot andEvent: anEvent.
	leftView
		onAnswer: [ :value | 
			value isNil
				ifFalse: [ shoot save ].
			leftView := nil ]! !

!ViewEvent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 13:28'!
showWinners: anEvent
	"Update honors"
	anEvent createHonors.
	
	leftView := ViewShowEventRankings newWithShoot: shoot andEvent: anEvent.

	anEvent createHonors.

	leftView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot save. 
			].
			leftView := nil. 
		 ]! !

!ViewEvent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/23/2013 00:24'!
updateRoot: anHtmlRoot
   super updateRoot: anHtmlRoot.
   anHtmlRoot stylesheet url: (MyFileLibrary urlOf: #bootstrapCss ).
   anHtmlRoot javascript url: (MyFileLibrary urlOf: #bootstrapJss ).! !

WAComponent subclass: #ViewMain
	instanceVariableNames: 'addShootView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewMain class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/22/2013 15:01'!
initialize
    "self initialize"
   ( WAAdmin register: self asApplicationAt: 'simpleskeet')
	addLibrary: JQDeploymentLibrary;
	addLibrary: JQUiDeploymentLibrary ;
	addLibrary: JQBaseTheme.! !

!ViewMain methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 14:39'!
add
	"|newShoot|"
	"newShoot := self call: (ViewAddShoot new )."
      "newShoot isNil"
        "ifFalse: [ newShoot save ]."
	addShootView := ViewAddShoot new.
	addShootView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				addShootView shoot save. 
				
				].
			addShootView := nil.
		 ]! !

!ViewMain methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 12:48'!
children 
	^ Array with: addShootView.! !

!ViewMain methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 12:11'!
goToShoot: aShoot 
	self call: (ViewShoot new shoot: aShoot).
    ! !

!ViewMain methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/14/2013 15:10'!
remove: aShoot
	(self confirm: 'Are you sure you want to remove ' , aShoot name printString , '?')
        ifTrue: [ aShoot delete ].
    ! !

!ViewMain methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/29/2013 21:12'!
renderContentOn: html
	| allShoots "id"|
	Shoot newShootWithName: 'NewShoot'.
	allShoots := Shoot findAll.
	html div
		class: 'container';
		with: [ 
					html
						heading: [ 
							html anchor
								callback: [ self session presenter ];
								with: 'Simple Skeet' ].
					html break.
					html anchor
						class:'btn-small btn-info';
						callback: [ self add ];
						with: 'Add New Shoot'.
					html break.
					html break.
					html break.
					
					html div
					class: 'row';
					with: [ 	
					html div
					class: 'span6';
					
					with: [ 
					
						html  
							table 
							class: 'table';
							class: 'table-hover';
							"class: 'table-bordered';"
							with: [
							
							allShoots
								do: [ :shoot | 
									html tableRow: [ 
											html tableData 
											class: 'span5';
											with:[
												html anchor
												callback: [ self goToShoot: shoot ];
												with: shoot name.
												].
											html tableData: [ 
											html anchor
												class:'btn-small btn-danger';
												callback: [ self remove: shoot ];
												with: 'remove' 
												
												
												"html div
      												id: (id := html nextId);
      												script: (html jQuery new dialog
        													title: 'Confirmation';
         													autoOpen: false;
         													addButton: 'Yes' do: ( (html  jQuery ajax) script: [:s | shoot delete ]);
														addButton: 'No' do: html jQuery new dialog close
													);
													with: [ html text: 'Are you sure you want to remove ', shoot name printString , '?' ].
  													 
												html submitButton
														class:'btn-small btn-danger';
      													onClick: (html jQuery id: id) dialog open;
     												 with: 'Delete'."
												
												
												 "html div
    													 id: (id := html nextId);
     													script: (html jQuery new dialog
        													 title: 'Lightbox Dialog';
														autoOpen: false;
        													 modal: true);
     													with: [ html text: 'Sure?'].
 												html submitButton
     													onClick: (html jQuery id: id) dialog open;
   													 with: 'Delete'."
												
												].
												]
												 
									] 
						  ] .
									
						].
							html div
								class: 'span6';
								with: [ 	
									html break.
									html render: addShootView.
								].
							
							].
								
							]. ! !

!ViewMain methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/21/2013 11:41'!
updateRoot: anHtmlRoot
   super updateRoot: anHtmlRoot.
   anHtmlRoot stylesheet url: (MyFileLibrary urlOf: #bootstrapCss ).
   anHtmlRoot javascript url: (MyFileLibrary urlOf: #bootstrapJss ).
    ! !

WAComponent subclass: #ViewShoot
	instanceVariableNames: 'shoot addEventView addShooterView showShootersView showEventsView rightView leftView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/29/2013 18:25'!
addCompositeEvent
	
	rightView := ViewAddCompositeEvent new.
	rightView compositeEvent: ((CompositeEvent newEventWithName: 'No Name') shoot: shoot).
	rightView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot addCompositeEvent:  ( rightView compositeEvent ). 
				shoot save.
				
				].
		rightView := nil.
	]! !

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/24/2013 16:35'!
addEvent
	
	rightView := ViewAddEvent new.
	rightView event: (Event newEventWithName: 'No Name' shoot: shoot).
	rightView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot addEvent:  ( rightView event ). 
				shoot save.
				
				].
		rightView := nil.
	]! !

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/22/2013 16:18'!
addShooter
	
	rightView := ViewAddShooter new.
	rightView shooter: (Shooter newShooterFirstName: 'No Name' shoot: shoot).
	rightView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot addShooter:  ( rightView shooter ). 
				shoot save.
				].
		rightView := nil.
		 ]! !

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:30'!
children 
	^ {addEventView . addShooterView . showShootersView . showEventsView} asArray.! !

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/22/2013 16:22'!
hide
	
	leftView := nil.! !

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/22/2013 22:19'!
hideRight
	
	rightView := nil.! !

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 19:55'!
renderContentOn: html
	html div
		class: 'container';
		with: [ 
					html
						heading: [ 
							html anchor
								callback: [ self answer: nil ];
								with: 'Simple Skeet' ].
					html anchor
						class: 'label';
						callback: [ self session presenter goToShoot: shoot ];
						with: 'Shoot Name: ' , shoot name.
					html break.
					html break.
					html div
						class: 'row';
						with: [ 
									html div
										class: 'span7';
										with: [ 
													html anchor
														class: 'btn-small btn-success';
														callback: [ self showEvents ];
														with: 'Show Events'.
													html space.
													html anchor
														class: 'btn-small btn-success';
														callback: [ self showShooters ];
														with: 'Show Shooters'.
													html space.
													html anchor
														class: 'btn-small btn-success';
														callback: [ self hide ];
														with: 'Hide'.
													html break.
													html break.
													html render: leftView ].
									html div
										class: 'span5';
										with: [ 

													html anchor
														class: 'btn-small btn-info';
														callback: [ self addEvent ];
														with: 'Add New Event'.
													html space.
													html anchor
														class: 'btn-small btn-info';
														callback: [ self addCompositeEvent ];
														with: 'Add New CompositeEvent'.
													html break.
													html anchor
														class: 'btn-small btn-info';
														callback: [ self addShooter ];
														with: 'Add New Shooter'.
													html space.
													html anchor
														class: 'btn-small btn-info';
														callback: [ self hideRight ];
														with: 'Hide'.
													html break.
													html break.
													html render: rightView ] ] ]! !

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/14/2013 15:15'!
shoot
	^ shoot.! !

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/14/2013 15:15'!
shoot: aShoot
	shoot := aShoot.! !

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/22/2013 22:39'!
showEvents
	
	leftView := ViewShowEvents newWithShoot: shoot.
	leftView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
			
				rightView := value. 
				shoot save.
			] .
		
	]! !

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/22/2013 22:39'!
showShooters
	
	leftView := ViewShowShooters newWithShoot: shoot.
	leftView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				rightView := value. 
				shoot save.
			] .
		
	]! !

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/22/2013 15:37'!
updateRoot: anHtmlRoot
   super updateRoot: anHtmlRoot.
   anHtmlRoot stylesheet url: (MyFileLibrary urlOf: #bootstrapCss ).
   anHtmlRoot javascript url: (MyFileLibrary urlOf: #bootstrapJss ).! !

WAComponent subclass: #ViewShowEventRankings
	instanceVariableNames: 'shoot event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewShowEventRankings class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 08:29'!
newWithShoot: aShoot andEvent: anEvent
	^(self new) shoot: aShoot; event: anEvent.! !

!ViewShowEventRankings methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 08:29'!
children 
	^ { } asArray.! !

!ViewShowEventRankings methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 08:29'!
event
	^event.! !

!ViewShowEventRankings methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 08:29'!
event: anEvent
	event := anEvent.! !

!ViewShowEventRankings methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/30/2013 01:05'!
renderContentOn: html
	| tmpRankings prevRanks |
	event shooters size == 0
		ifTrue: [ html text: 'No Shooters.' ].
	event
		honorsDo: [ :eachHonor | 
			html div
				class: 'my-hero';
				with: [ 
							html heading: eachHonor type level: 5.
							prevRanks := 0.
							eachHonor isResolved
								ifTrue: [ 
									tmpRankings := eachHonor winners.
									tmpRankings
										do: [ :eachShooter | 
											html space.
											html space.
											prevRanks := prevRanks + 1.
											html text: prevRanks asString , '.'.
											html space.
											html space.
											html strong with: eachShooter name.
											html space.
											html text: (event getTotalScoreFor: eachShooter) ]
										separatedBy: [ 
											html text: ','.
											html space ].
									html break ].
							tmpRankings := eachHonor rankings.
							tmpRankings
								associationsDo: [ :eachShooterRank | 
									eachShooterRank value size > 0
										ifTrue: [ 
											html space.
											html space.
											html text: (1 + prevRanks) asString , '.'.
											prevRanks := prevRanks + eachShooterRank value size.
											html space.
											html space.
											eachShooterRank value
												do: [ :eachShooter | 
													html text: eachShooter name.
													html space.
													html text: (event getTotalScoreFor: eachShooter) ]
												separatedBy: [ 
													html text: ','.
													html space ].
											html break ] ] ] ]! !

!ViewShowEventRankings methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 08:29'!
shoot
	^ shoot.
		! !

!ViewShowEventRankings methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 08:29'!
shoot: aShoot
	shoot := aShoot.
		! !

WAComponent subclass: #ViewShowEventScores
	instanceVariableNames: 'shoot event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewShowEventScores class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 07:34'!
newWithShoot: aShoot andEvent: anEvent
	^(self new) shoot: aShoot; event: anEvent.! !

!ViewShowEventScores methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 07:39'!
children 
	^ { } asArray.! !

!ViewShowEventScores methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 07:35'!
event
	^event.! !

!ViewShowEventScores methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 07:35'!
event: anEvent
	event := anEvent.! !

!ViewShowEventScores methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/29/2013 21:58'!
renderContentOn: html
	| tmpScore tmpScoreNew tmpScoresNew |
	tmpScoresNew := Dictionary new.
	html break.
	event shooters size == 0
		ifTrue: [ html text: 'No Shooters.' ].
	html
		form: [ 
			html table
				class: 'table';
				class: 'table-hover';
				with: [ 
					
					
					
							event shooters
								do: [ :eachShooter | 
									
									html tableRow: [ 
									html tableData
										class: 'span2';
										with: [ 
													html div
													class: 'my-strong';
													with:[
													html text: eachShooter name.
													].].
												
									html tableData
										class: 'span1';
										with: [
											
											html div 
												class: 'text-error bold';
												with: [ 
												html heading:
												 (event getTotalScoreFor: eachShooter) level: 5.	
													].
										].
									
									html tableData
										class: 'span4';
										with: [
											tmpScore := event getScoreFor: eachShooter.
									tmpScoreNew := OrderedCollection new.
									tmpScoresNew at: eachShooter put: tmpScoreNew.
									tmpScore
										do: [ :eachRound | 
											html textInput
												class: 'input-mini-mini';
												value: eachRound;
												callback: [ :value | (tmpScoresNew at: eachShooter) add: value ] ]
										separatedBy: [ html space ]. 
													
													].
												
												
										].		
									
									
									 ]
								].
			html break.
			html submitButton
				callback: [ 
							event setScores: tmpScoresNew.
							self answer: shoot ];
				text: 'Save'	"html cancelButton
            callback: [ self answer: nil ];
           	text: 'Cancel' " ]! !

!ViewShowEventScores methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 07:33'!
shoot
	^ shoot.
		! !

!ViewShowEventScores methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 07:33'!
shoot: aShoot
	shoot := aShoot.
		! !

WAComponent subclass: #ViewShowEventShootoffs
	instanceVariableNames: 'shoot event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewShowEventShootoffs class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 08:25'!
newWithShoot: aShoot andEvent: anEvent
	^(self new) shoot: aShoot; event: anEvent.! !

!ViewShowEventShootoffs methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 08:25'!
children 
	^ { } asArray.! !

!ViewShowEventShootoffs methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 08:25'!
event
	^event.! !

!ViewShowEventShootoffs methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 08:25'!
event: anEvent
	event := anEvent.! !

!ViewShowEventShootoffs methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/30/2013 00:22'!
renderContentOn: html
	event numShootoffs == 0
		ifTrue: [ html text: 'No Shootoffs.' ].
	event
		shootoffsDo: [ :eachShootoff | 
			html div
				class: 'my-hero';
				with: [ 
							html heading: eachShootoff honor type level: 5.
							eachShootoff shooters
								do: [ :eachShooter | 
									html space.
									html space.
									html space.
									html space.
									html text: eachShooter name ]
								separatedBy: [ html break ].
							html break ].
			html break ]! !

!ViewShowEventShootoffs methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 08:25'!
shoot
	^ shoot.
		! !

!ViewShowEventShootoffs methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 08:25'!
shoot: aShoot
	shoot := aShoot.
		! !

WAComponent subclass: #ViewShowEvents
	instanceVariableNames: 'shoot addEventView event showEventScoresView showEventShootoffsView showEventRankingsView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewShowEvents class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:23'!
newWithShoot: aShoot 
	^self new shoot: aShoot.! !

!ViewShowEvents methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 08:32'!
children 
	^ { addEventView . showEventScoresView . showEventRankingsView . showEventShootoffsView } asArray.! !

!ViewShowEvents methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/23/2013 10:53'!
goToEvent: anEvent shoot: aShoot 
	self call: (ViewEvent new shoot: aShoot event: anEvent).! !

!ViewShowEvents methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/22/2013 23:05'!
removeEvent: anEvent
	(self confirm: 'Are you sure you want to remove ' , anEvent name printString , '?')
        ifTrue: [ shoot removeEvent: anEvent .
		shoot save.
	 ].! !

!ViewShowEvents methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 19:58'!
renderContentOn: html
	html break.
	html render: addEventView.
	html break.
	html table
		class: 'table';
		class: 'table-hover';
		with: [ 
					"class: 'table-bordered';"
					shoot events
						do: [ :eachEvent | 
							html
								tableRow: [ 
									html tableData
										class: 'span5';
										with: [ 
													html anchor
														callback: [ self goToEvent: eachEvent shoot: shoot ];
														with: eachEvent name ].
									html tableData
										class: 'span1';
										with: [ 
													html
														form: [ 
															html submitButton
																class: 'btn-mini btn-warning';
																callback: [ 
																			self
																				answer:
																					(eachEvent class = CompositeEvent
																						ifFalse: [ ViewAddEvent newWithEvent: eachEvent ]
																						ifTrue: [ ViewAddCompositeEvent newWithCompositeEvent: eachEvent ]) ];
																text: 'Update' ] ].
									html tableData
										class: 'span1';
										with: [ 
													html anchor
														class: 'btn-small btn-danger';
														callback: [ self removeEvent: eachEvent ];
														with: 'Remove' ] ]	"html space.
			
			html space.
			html anchor
					callback: [ self showScores: eachEvent ];
					with: 'Show Scores'.
			html space.
			html anchor
					callback: [ self showWinners: eachEvent ];
					with: 'Show Winners'.
			html space.
			html anchor
					callback: [ self showShootoffs: eachEvent ];
					with: 'Display Shootoffs'.
					" ]	"html break.
	html render: showEventScoresView.
	html break.
	html render: showEventShootoffsView.
	html break.
	html render: showEventRankingsView.
	html break." ]	"html form: [
  		
        	html cancelButton
        	    callback: [ self answer: nil ];
        	    text: 'Hide Events' ]. "! !

!ViewShowEvents methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:23'!
shoot
	^ shoot.
		! !

!ViewShowEvents methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:23'!
shoot: aShoot
	shoot := aShoot.
		! !

!ViewShowEvents methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/29/2013 18:43'!
showEvent: anEvent
	addEventView := (anEvent class = CompositeEvent) ifFalse: [ViewAddEvent newWithEvent: anEvent] ifTrue: [ViewAddCompositeEvent newWithCompositeEvent: anEvent].
	Transcript show: anEvent name.
	addEventView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot save. 
			].
			addEventView := nil.
		 ]! !

!ViewShowEvents methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 08:32'!
showRankings: anEvent
	showEventRankingsView := ViewShowEventRankings newWithShoot: shoot andEvent: anEvent.

	showEventRankingsView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot save. 
			].
			showEventRankingsView := nil. 
		 ]! !

!ViewShowEvents methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 07:38'!
showScores: anEvent
	showEventScoresView := ViewShowEventScores newWithShoot: shoot andEvent: anEvent.

	showEventScoresView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot save. 
			].
			showEventScoresView := nil. 
		 ]! !

!ViewShowEvents methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 13:27'!
showShootoffs: anEvent

	showEventShootoffsView := ViewShowEventShootoffs newWithShoot: shoot andEvent: anEvent.

	showEventShootoffsView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot save. 
			].
			showEventShootoffsView := nil. 
		 ]! !

!ViewShowEvents methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 08:39'!
showWinners: anEvent
	showEventRankingsView := ViewShowEventRankings newWithShoot: shoot andEvent: anEvent.

	anEvent createHonors.

	showEventRankingsView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot save. 
			].
			showEventRankingsView := nil. 
		 ]! !

WAComponent subclass: #ViewShowResolveEventShootoffs
	instanceVariableNames: 'shoot event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewShowResolveEventShootoffs class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 14:13'!
newWithShoot: aShoot andEvent: anEvent
	^(self new) shoot: aShoot; event: anEvent.! !

!ViewShowResolveEventShootoffs methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 14:13'!
children 
	^ { } asArray.! !

!ViewShowResolveEventShootoffs methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 14:52'!
downShooter: aShooter inShootoff: aShootoff 
	| shooterIndex |
	shooterIndex := aShootoff shooters indexOf: aShooter.
	aShootoff shooters swap: shooterIndex with: (shooterIndex + 1).! !

!ViewShowResolveEventShootoffs methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 14:13'!
event
	^event.! !

!ViewShowResolveEventShootoffs methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 14:13'!
event: anEvent
	event := anEvent.! !

!ViewShowResolveEventShootoffs methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/30/2013 08:31'!
renderContentOn: html
	| myLabel |
	event numShootoffs == 0
		ifTrue: [ html text: 'No Shootoffs Generated!!' ].
	html
		form: [ 
			event
				shootoffsDo: [ :eachShootoff | 
					html div
						class: 'my-hero';
						with: [ 
									html heading: eachShootoff honor type level: 5.
									eachShootoff shooters
										do: [ :eachShooter | 
											html space.
											html space.
											(eachShootoff shooters indexOf: eachShooter) > 1
												ifTrue: [ 
													html space.
													html anchor
														class: 'btn-small btn-info';
														callback: [ self upShooter: eachShooter inShootoff: eachShootoff ];
														with: '^' ]
												ifFalse: [ 
													html space.
													html anchor
														class: 'btn-small btn-info';
														with: '^' ].
											html space.
											(eachShootoff shooters indexOf: eachShooter) < eachShootoff shooters size
												ifTrue: [ 
													html anchor
														class: 'btn-small btn-info';
														callback: [ self downShooter: eachShooter inShootoff: eachShootoff ];
														with: 'v' ]
												ifFalse: [ 
													html anchor
														class: 'btn-small btn-info';
														with: 'v' ].
											html space.
											html space.
											html text: eachShootoff rank - 1 + (eachShootoff shooters indexOf: eachShooter).
											html text: '. '.
											html text: eachShooter name ]
										separatedBy: [ 
											html text: ','.
											html break ].
									html break.
									html break.
									myLabel := ''.
									eachShootoff isResolved
										ifTrue: [ myLabel := 'my-label my-label-done' ]
										ifFalse: [ myLabel := 'my-label' ].
									html div
										class: myLabel;
										with: [ 
													html checkbox
														value: eachShootoff isResolved;
														callback: [ :value | 
																	value
																		ifTrue: [ eachShootoff resolvedWith: (OrderedCollection newFrom: eachShootoff shooters) ]
																		ifFalse: [ eachShootoff clearResolved ] ].
													html space.
													html text: 'Resolved' ].
									html break ] ].
			html break.
			html submitButton
				callback: [ self answer: shoot ];
				text: 'Save'.
			html cancelButton
				callback: [ self answer: nil ];
				text: 'Cancel' ]! !

!ViewShowResolveEventShootoffs methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 14:13'!
shoot
	^ shoot.
		! !

!ViewShowResolveEventShootoffs methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 14:13'!
shoot: aShoot
	shoot := aShoot.
		! !

!ViewShowResolveEventShootoffs methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 14:52'!
upShooter: aShooter inShootoff: aShootoff 
	| shooterIndex |
	shooterIndex := aShootoff shooters indexOf: aShooter.
	aShootoff shooters swap: shooterIndex with: (shooterIndex - 1).! !

WAComponent subclass: #ViewShowShooters
	instanceVariableNames: 'shoot addShooterView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewShowShooters class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:40'!
newWithShoot: aShoot 
	^self new shoot: aShoot.! !

!ViewShowShooters class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/22/2013 22:22'!
newWithShoot: aShoot rightView: aView
	^self new shoot: aShoot view: aView.! !

!ViewShowShooters methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:07'!
children 
	^ { addShooterView} asArray.! !

!ViewShowShooters methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 18:56'!
removeShooter: aShooter
	(self confirm: 'Are you sure you want to remove ' , aShooter name printString , '?')
        ifTrue: [ shoot removeShooter: aShooter.
		shoot save.
	 ].! !

!ViewShowShooters methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 20:01'!
renderContentOn: html
	
	html break.
	html render: addShooterView.
	html break.
	
	html  table 
		class: 'table';
		class: 'table-hover';
		"class: 'table-bordered';"
		with: [
								
								
								
	shoot shooters do: [ :shooter | 
		html tableRow: [ 
			html tableData 
				class: 'span5';
				with:[
					html text: (shooter name).].
			
		html tableData 
				class: 'span1';
				with:[
					"html anchor
					class: 'btn-small btn-warning';
                			callback: [ self showShooter:   shooter ];
                			with: 'Update'."
					html form: [ 
					html submitButton
						class: 'btn-mini btn-warning';
            				callback: [ self answer: (ViewAddShooter newWithShooter:shooter) ];
            				text: 'Update'.
					].
				].
			html tableData 
				class: 'span1';
				with:[
					html anchor
					class: 'btn-small btn-danger';
                			callback: [ self removeShooter:   shooter ];
                			with: 'Remove'.]
											
											
			
			].
		].
	].! !

!ViewShowShooters methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:32'!
shoot
	^ shoot.
		! !

!ViewShowShooters methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:40'!
shoot: aShoot
	shoot := aShoot.
		! !

!ViewShowShooters methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 19:08'!
showShooter: aShooter
	addShooterView := ViewAddShooter newWithShooter: aShooter.
	Transcript show: aShooter name.
	addShooterView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot save. 
			].
			addShooterView := nil.
		 ]! !

SDActiveRecord subclass: #Shoot
	instanceVariableNames: 'name shooters events compositeEvent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!Shoot class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:54'!
newShootWithName: aName 	
	^ self new shootWithName: aName.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/29/2013 18:31'!
addCompositeEvent: aCompositeEvent
	events add: aCompositeEvent.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:56'!
addEvent: anEvent
	events add: anEvent.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:56'!
addShooter: aShooter 
	shooters add: aShooter.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/24/2013 17:15'!
enteredEvent: anEvent 
	^events includes: anEvent. ! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 12:06'!
events
	^events.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/14/2013 12:00'!
name
	^name.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/14/2013 12:00'!
printOn: aStream
	aStream nextPutAll: self name.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/22/2013 23:07'!
removeEvent: anEvent 
	events remove: anEvent.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 18:56'!
removeShooter: aShooter 
	shooters remove: aShooter.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 16:07'!
shootWithName: aName
	name:= aName.
	shooters := OrderedCollection new.
	events := OrderedCollection new.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 12:06'!
shooters
	^shooters.! !

TestCase subclass: #EventTestCase
	instanceVariableNames: 'event renk henry varney jenny tom1 tom2 tony randy paul greg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!EventTestCase methodsFor: 'running' stamp: 'HenryDuwe 7/16/2013 06:10'!
setUp

	"Create an Event"
	| eventType |
	Transcript show: 'blah'.
	eventType := Gauge12 new.
	event := Event newEventWithName: '12 Ga Event' andType: eventType.
	
  	"Create some Shooters"
	renk := Shooter newShooterFirstName: 'Jeff' shoot: nil.
	renk middleName: ''; lastName: 'Renk'.
	renk addConcurrent: SeniorConcurrent new.
	renk setClass: (CClass new) forEvent: (Gauge12 new) withAverage: 0.9000.
	
	henry := Shooter newShooterFirstName: 'Henry' shoot: nil.
	henry middleName: 'John'; lastName: 'Duwe'.
	henry addConcurrent: TripleSubSeniorConcurrent new.
	henry setClass: (AClass new) forEvent: (Gauge12 new) withAverage: 0.9600.
	
	varney := Shooter newShooterFirstName: 'Jeff' shoot: nil.
	varney middleName: ''; lastName: 'Varney'.
	varney addConcurrent: TripleSubSeniorConcurrent new.
	varney setClass: (AAClass new) forEvent: (Gauge12 new) withAverage: 0.9600.
	
	jenny := Shooter newShooterFirstName: 'Jenny' shoot: nil.
	jenny middleName: ''; lastName: 'Notstad'.
	jenny addConcurrent: TripleSubSeniorConcurrent new.
	jenny addConcurrent: LadyConcurrent new.
	jenny setClass: (CClass new) forEvent: (Gauge12 new) withAverage: 0.9000.
	
	tom1 := Shooter newShooterFirstName: 'Tom' shoot: nil.
	tom1 middleName: ''; lastName: 'McDaniels'.
	tom1 addConcurrent: SeniorConcurrent new.
	tom1 setClass: (DClass new) forEvent: (Gauge12 new) withAverage: 0.8900.
	
	tom2 := Shooter newShooterFirstName: 'Tom' shoot: nil.
	tom2 middleName: ''; lastName: 'Steinbeck'.
	tom2 addConcurrent: SeniorConcurrent new.
	tom2 setClass: (BClass new) forEvent: (Gauge12 new) withAverage: 0.9100.
	
	tony := Shooter newShooterFirstName: 'Tony' shoot: nil.
	tony middleName: ''; lastName: 'Pavelka'.
	tony addConcurrent: SubSeniorConcurrent new.
	tony setClass: (EClass new) forEvent: (Gauge12 new) withAverage: 0.8500.
	
	randy := Shooter newShooterFirstName: 'Randy' shoot: nil.
	randy middleName: ''; lastName: 'Riehle'. 
	randy addConcurrent: SeniorConcurrent new.
	randy setClass: (AClass new) forEvent: (Gauge12 new) withAverage: 0.9650.

	paul := Shooter newShooterFirstName: 'Paul' shoot: nil.
	paul middleName: 'David'; lastName: 'Friesen'.
	paul addConcurrent: SeniorConcurrent new.
	paul setClass: (BClass new) forEvent: (Gauge12 new) withAverage: 0.9590.
	
	greg := Shooter newShooterFirstName: 'Greg' shoot: nil.
	greg middleName: ''; lastName: 'Schweppe'.
	greg addConcurrent: SeniorConcurrent new.
	greg setClass: (AClass new) forEvent: (Gauge12 new) withAverage: 0.9540.
	
	"Add them to Event"
	event addShooter: renk.
	event addShooter: henry.
	event addShooter: varney.
	event addShooter: jenny.
	event addShooter: tom1.
	event addShooter: tom2.
	event addShooter: tony.
	event addShooter: randy.
	event addShooter: paul.
	event addShooter: greg.! !

!EventTestCase methodsFor: 'testing' stamp: 'HenryDuwe 7/23/2013 10:27'!
testHonors
	"| honors theAHonor |"
	
	"Enter scores"
	| honors theAHonor score|
	score := OrderedCollection new.
	score add: 24; add: 24; add: 24; add: 25.
	event setScore: score for: randy.
	score := OrderedCollection new.
	score add: 24; add: 24; add: 24; add: 24.
	event setScore: score for: varney.
	score := OrderedCollection new.
	score add: 22; add: 24; add: 25; add: 25.
	event setScore: score for: henry.
	score := OrderedCollection new.
	score add: 24; add: 24; add: 24; add: 25.
	event setScore: score for: greg.
	event setScore: { 20 . 24 . 24 . 24 } for: paul.
	event setScore: { 23 . 22 . 23 . 22 } for: renk.
	event setScore: { 22 . 23 . 22 . 23 } for: jenny.
	event setScore: { 21 . 24 . 20 . 22 } for: tom1.
	event setScore: { 24 . 22 . 21 . 21 } for: tony.
	
	"Create honors and rank"
	event createHonors.
	
	"Test A Class rankings"
	honors := event honors.
	theAHonor := honors detect: [ :each | (each type) = (AClass new) ].
	self assert: ((((theAHonor rankings) at: 1) at: 1)== randy).
	self assert: ((((theAHonor rankings) at: 1) at: 2) == greg).
	self assert: ((((theAHonor rankings) at: 2) at: 1)== henry).
	
	"Generate shootoffs"
      event generateHonors.
	self assert: ((((event shootoffs) at: theAHonor) size) = 1).
	
	"Resolve shootoff"
	(((event shootoffs) at: theAHonor) at: 1) resolvedWith: { randy . greg }.
	
	"Test A Class winners"
	self assert: (theAHonor winners size = 1).
	self assert: (theAHonor resolved).
	self assert: ((theAHonor winners at: 1) = randy).! !

!EventTestCase methodsFor: 'testing' stamp: 'HenryDuwe 7/16/2013 06:13'!
testRanking
	"| honors theAHonor |"
	
	"Enter scores"
	| honors theAHonor score|
	score := OrderedCollection new.
	score add: 24; add: 24; add: 24; add: 25.
	event setScore: score for: randy.
	score := OrderedCollection new.
	score add: 24; add: 24; add: 24; add: 24.
	event setScore: score for: varney.
	score := OrderedCollection new.
	score add: 22; add: 24; add: 25; add: 25.
	event setScore: score for: henry.
	score := OrderedCollection new.
	score add: 23; add: 24; add: 23; add: 25.
	event setScore: score for: greg.
	event setScore: { 20 . 24 . 24 . 24 } for: paul.
	event setScore: { 23 . 22 . 23 . 22 } for: renk.
	event setScore: { 22 . 23 . 22 . 23 } for: jenny.
	event setScore: { 21 . 24 . 20 . 22 } for: tom1.
	event setScore: { 24 . 22 . 21 . 21 } for: tony.
	
	"Create honors and rank"
	event createHonors.
	
	"Test A Class rankings"
	honors := event honors.
	theAHonor := honors detect: [ :each | (each type) = (AClass new) ].
	self assert: ((((theAHonor rankings) at: 1) at: 1)== randy).
	self assert: ((((theAHonor rankings) at: 2) at: 1)== henry).
	self assert: ((((theAHonor rankings) at: 3) at: 1) == greg).
! !

TestCase subclass: #ShootTestCase
	instanceVariableNames: 'shoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ShootTestCase commentStamp: '<historical>' prior: 0!
A ShootTestCase tests the skeet shoot manager application in all its various ways. It includes large-scale real tests for shoots.!

!ShootTestCase class methodsFor: 'private' stamp: 'HenryDuwe 7/30/2013 10:02'!
insertMikeKipp
	| event12 eventDoubles event28 event410 henry paul renk varney jenny tom1 tom2 tony randy greg score event shoot eventHOA eventsHOA |
	"Setup shoot."
	shoot := Shoot newShootWithName: 'Mike Kipp 2013'.
	eventDoubles := Event
		newEventWithName: 'Doubles Event'
		andType: Doubles new
		withScoreFormat:
			{24.
			26.
			24.
			26}.
	shoot addEvent: eventDoubles.
	event12 := Event newEventWithName: '12ga Event' andType: Gauge12 new.
	event12 shoot: shoot.
	shoot addEvent: event12.
	event28 := Event newEventWithName: '28ga Event' andType: Gauge28 new.
	event28 shoot: shoot.
	shoot addEvent: event28.
	event410 := Event newEventWithName: '410bore Event' andType: Bore410 new.
	event410 shoot: shoot.
	shoot addEvent: event410.
	eventsHOA := OrderedCollection new.
	eventsHOA
		add: event12;
		add: event28;
		add: event410;
		add: eventDoubles.
	eventHOA := CompositeEvent newEventWithName: 'HOA Event' andEvents: eventsHOA.
	eventHOA shoot: shoot.
	shoot addEvent: eventHOA.	"Add shooters"
	renk := Shooter newShooterFirstName: 'Jeff' shoot: nil.
	renk
		middleName: '';
		lastName: 'Renk'.
	renk addConcurrent: SeniorConcurrent new.
	renk setClass: CClass new forEvent: Gauge12 new withAverage: 0.9000.
	renk setClass: BClass new forEvent: Gauge28 new withAverage: 0.9000.
	renk setClass: BClass new forEvent: Bore410 new withAverage: 0.9000.
	renk setClass: BClass new forEvent: Doubles new withAverage: 0.9000.
	henry := Shooter newShooterFirstName: 'Henry' shoot: nil.
	henry
		middleName: 'John';
		lastName: 'Duwe'.
	henry addConcurrent: TripleSubSeniorConcurrent new.
	henry setClass: AClass new forEvent: Gauge12 new withAverage: 0.9600.
	henry setClass: AAClass new forEvent: Gauge28 new withAverage: 0.9600.
	henry setClass: AAClass new forEvent: Bore410 new withAverage: 0.9600.
	henry setClass: AClass new forEvent: Doubles new withAverage: 0.9600.
	varney := Shooter newShooterFirstName: 'Jeff' shoot: nil.
	varney
		middleName: '';
		lastName: 'Varney'.
	varney addConcurrent: TripleSubSeniorConcurrent new.
	varney setClass: AAClass new forEvent: Gauge12 new withAverage: 0.9600.
	varney setClass: AAClass new forEvent: Gauge28 new withAverage: 0.9600.
	varney setClass: AAClass new forEvent: Bore410 new withAverage: 0.9600.
	varney setClass: BClass new forEvent: Doubles new withAverage: 0.9600.
	jenny := Shooter newShooterFirstName: 'Jenny' shoot: nil.
	jenny
		middleName: '';
		lastName: 'Notstad'.
	jenny addConcurrent: TripleSubSeniorConcurrent new.
	jenny addConcurrent: LadyConcurrent new.
	jenny setClass: CClass new forEvent: Gauge12 new withAverage: 0.9000.
	jenny setClass: BClass new forEvent: Gauge28 new withAverage: 0.9000.
	jenny setClass: BClass new forEvent: Bore410 new withAverage: 0.9000.
	jenny setClass: BClass new forEvent: Doubles new withAverage: 0.9000.
	tom1 := Shooter newShooterFirstName: 'Tom' shoot: nil.
	tom1
		middleName: '';
		lastName: 'McDaniels'.
	tom1 addConcurrent: SeniorConcurrent new.
	tom1 setClass: DClass new forEvent: Gauge12 new withAverage: 0.8900.
	tom1 setClass: CClass new forEvent: Gauge28 new withAverage: 0.8900.
	tom1 setClass: CClass new forEvent: Doubles new withAverage: 0.8900.
	tom2 := Shooter newShooterFirstName: 'Tom' shoot: nil.
	tom2
		middleName: '';
		lastName: 'Steinbeck'.
	tom2 addConcurrent: SeniorConcurrent new.
	tom2 setClass: BClass new forEvent: Gauge12 new withAverage: 0.9100.
	tom2 setClass: CClass new forEvent: Gauge28 new withAverage: 0.9100.
	tom2 setClass: BClass new forEvent: Bore410 new withAverage: 0.9100.
	tony := Shooter newShooterFirstName: 'Tony' shoot: nil.
	tony
		middleName: '';
		lastName: 'Pavelka'.
	tony addConcurrent: SubSeniorConcurrent new.
	tony setClass: EClass new forEvent: Gauge12 new withAverage: 0.8500.
	tony setClass: CClass new forEvent: Doubles new withAverage: 0.8500.
	randy := Shooter newShooterFirstName: 'Randy' shoot: nil.
	randy
		middleName: '';
		lastName: 'Riehle'.
	randy addConcurrent: SeniorConcurrent new.
	randy setClass: AClass new forEvent: Gauge12 new withAverage: 0.9650.
	randy setClass: AAClass new forEvent: Gauge28 new withAverage: 0.9650.
	randy setClass: AClass new forEvent: Bore410 new withAverage: 0.9650.
	randy setClass: BClass new forEvent: Doubles new withAverage: 0.9650.
	paul := Shooter newShooterFirstName: 'Paul' shoot: nil.
	paul
		middleName: 'David';
		lastName: 'Friesen'.
	paul addConcurrent: SeniorConcurrent new.
	paul setClass: BClass new forEvent: Gauge12 new withAverage: 0.9590.
	paul setClass: AAClass new forEvent: Gauge28 new withAverage: 0.9590.
	paul setClass: BClass new forEvent: Bore410 new withAverage: 0.9590.
	paul setClass: AClass new forEvent: Doubles new withAverage: 0.9590.
	greg := Shooter newShooterFirstName: 'Greg' shoot: nil.
	greg
		middleName: '';
		lastName: 'Schweppe'.
	greg addConcurrent: SeniorConcurrent new.
	greg setClass: AClass new forEvent: Gauge12 new withAverage: 0.9540.
	greg setClass: BClass new forEvent: Gauge28 new withAverage: 0.9540.
	greg setClass: BClass new forEvent: Bore410 new withAverage: 0.9540.
	greg setClass: BClass new forEvent: Doubles new withAverage: 0.9540.	"Add shooters to shoot."
	shoot addShooter: renk.
	shoot addShooter: henry.
	shoot addShooter: varney.
	shoot addShooter: jenny.
	shoot addShooter: tom1.
	shoot addShooter: tom2.
	shoot addShooter: tony.
	shoot addShooter: randy.
	shoot addShooter: paul.
	shoot addShooter: greg.	"Add them to Event"
	event12 addShooter: renk.
	event12 addShooter: henry.
	event12 addShooter: varney.
	event12 addShooter: jenny.
	event12 addShooter: tom1.
	event12 addShooter: tom2.
	event12 addShooter: tony.
	event12 addShooter: randy.
	event12 addShooter: paul.
	event12 addShooter: greg.
	event28 addShooter: renk.
	event28 addShooter: henry.
	event28 addShooter: varney.
	event28 addShooter: jenny.
	event28 addShooter: tom1.
	event28 addShooter: tom2.
	event28 addShooter: randy.
	event28 addShooter: paul.
	event28 addShooter: greg.
	event410 addShooter: renk.
	event410 addShooter: henry.
	event410 addShooter: varney.
	event410 addShooter: jenny.
	event410 addShooter: tom2.
	event410 addShooter: randy.
	event410 addShooter: paul.
	event410 addShooter: greg.
	eventDoubles addShooter: renk.
	eventDoubles addShooter: henry.
	eventDoubles addShooter: varney.
	eventDoubles addShooter: jenny.
	eventDoubles addShooter: tom1.
	eventDoubles addShooter: tony.
	eventDoubles addShooter: randy.
	eventDoubles addShooter: paul.
	eventDoubles addShooter: greg.	"Enter scores"
	eventHOA addShooter: randy.
	eventHOA addShooter: varney.
	eventHOA addShooter: henry.
	eventHOA addShooter: jenny.
	eventHOA addShooter: paul.
	eventHOA addShooter: renk.
	eventHOA addShooter: greg.
	event := event12.
	score := OrderedCollection new.
	score
		add: 24;
		add: 24;
		add: 24;
		add: 25.
	event setScore: score for: randy.
	score := OrderedCollection new.
	score
		add: 24;
		add: 24;
		add: 24;
		add: 24.
	event setScore: score for: varney.
	score := OrderedCollection new.
	score
		add: 22;
		add: 24;
		add: 25;
		add: 25.
	event setScore: score for: henry.
	score := OrderedCollection new.
	score
		add: 24;
		add: 24;
		add: 24;
		add: 25.
	event setScore: score for: greg.
	event
		setScore:
			{20.
			24.
			24.
			24}
		for: paul.
	event
		setScore:
			{23.
			22.
			23.
			22}
		for: renk.
	event
		setScore:
			{22.
			23.
			22.
			23}
		for: jenny.
	event
		setScore:
			{21.
			24.
			20.
			22}
		for: tom1.
	event
		setScore:
			{25.
			25.
			25.
			22}
		for: tom2.
	event
		setScore:
			{24.
			22.
			21.
			21}
		for: tony.
	event := eventDoubles.
	score := OrderedCollection new.
	score
		add: 24;
		add: 24;
		add: 24;
		add: 23.
	event setScore: score for: randy.
	score := OrderedCollection new.
	score
		add: 23;
		add: 24;
		add: 24;
		add: 22.
	event setScore: score for: varney.
	score := OrderedCollection new.
	score
		add: 20;
		add: 22;
		add: 24;
		add: 26.
	event setScore: score for: henry.
	score := OrderedCollection new.
	score
		add: 21;
		add: 19;
		add: 20;
		add: 23.
	event setScore: score for: greg.
	event
		setScore:
			{23.
			24.
			24.
			24}
		for: paul.
	event
		setScore:
			{21.
			19.
			23.
			21}
		for: renk.
	event
		setScore:
			{17.
			20.
			20.
			20}
		for: jenny.
	event
		setScore:
			{20.
			20.
			20.
			22}
		for: tom1.
	event
		setScore:
			{20.
			21.
			21.
			21}
		for: tony.
	event := event28.
	score := OrderedCollection new.
	score
		add: 25;
		add: 25;
		add: 25;
		add: 25.
	event setScore: score for: randy.
	score := OrderedCollection new.
	score
		add: 25;
		add: 25;
		add: 24;
		add: 25.
	event setScore: score for: varney.
	score := OrderedCollection new.
	score
		add: 20;
		add: 22;
		add: 25;
		add: 25.
	event setScore: score for: henry.
	score := OrderedCollection new.
	score
		add: 25;
		add: 24;
		add: 20;
		add: 23.
	event setScore: score for: greg.
	event
		setScore:
			{25.
			25.
			24.
			25}
		for: paul.
	event
		setScore:
			{23.
			25.
			23.
			23}
		for: renk.
	event
		setScore:
			{24.
			24.
			24.
			25}
		for: jenny.
	event
		setScore:
			{20.
			20.
			20.
			17}
		for: tom1.
	event
		setScore:
			{24.
			24.
			20.
			23}
		for: tom2.
	event := event410.
	score := OrderedCollection new.
	score
		add: 25;
		add: 20;
		add: 25;
		add: 25.
	event setScore: score for: randy.
	score := OrderedCollection new.
	score
		add: 25;
		add: 25;
		add: 24;
		add: 20.
	event setScore: score for: varney.
	score := OrderedCollection new.
	score
		add: 20;
		add: 23;
		add: 25;
		add: 25.
	event setScore: score for: henry.
	score := OrderedCollection new.
	score
		add: 25;
		add: 24;
		add: 20;
		add: 23.
	event setScore: score for: greg.
	event
		setScore:
			{25.
			25.
			24.
			25}
		for: paul.
	event
		setScore:
			{23.
			22.
			23.
			23}
		for: renk.
	event
		setScore:
			{23.
			20.
			24.
			20}
		for: jenny.
	event
		setScore:
			{24.
			24.
			20.
			23}
		for: tom2.	"Save Shoot "
	shoot save! !

!ShootTestCase methodsFor: 'running' stamp: 'HenryDuwe 7/16/2013 06:16'!
setUp 	
	shoot := Shoot newShootWithName: 'Fun Shoot'.! !

!ShootTestCase methodsFor: 'testing' stamp: 'HenryDuwe 7/16/2013 06:15'!
testAddShooter
	shoot addShooter: (Shooter newShooterFirstName: 'Dustin' shoot: shoot).
	self assert: ((shoot shooters size) = 1).
	! !

!ShootTestCase methodsFor: 'testing' stamp: 'BiplabDeka 7/14/2013 11:11'!
testDB
	| |
	"Setup shoot."
	shoot := Shoot newShootWithName: 'Mike Kipp 2013'.
	
! !

!ShootTestCase methodsFor: 'testing' stamp: 'HenryDuwe 7/16/2013 06:31'!
testMikeKipp
	| shootoffs12 event12 eventDoubles event28 event410 henry paul renk varney jenny tom1 tom2 tony randy greg |
	"Setup shoot."
	shoot := Shoot newShootWithName: 'Mike Kipp 2013'.
	eventDoubles := Event newEventWithName: 'Doubles Event' andType: (Doubles new) .
	shoot addEvent: (eventDoubles).
	event12 := Event newEventWithName: '12ga Event' andType: (Gauge12 new) .
	shoot addEvent: (event12).
	event28 := Event newEventWithName: '28ga Event' andType: (Gauge28 new) .
	shoot addEvent: (event28).
	event410 := Event newEventWithName: '410bore Event' andType: (Bore410 new) .
	shoot addEvent: (event410).
	shoot addEvent: (CompositeEvent newEventNamed: 'HOA Event' WithEvents: {event12 . event28 . event410 . eventDoubles}).
			
	"Add shooters"
	renk := Shooter newShooterFirstName: 'Jeff' shoot: nil.
	renk middleName: ''; lastName: 'Renk'.
	renk addConcurrent: SeniorConcurrent new.
	renk setClass: (CClass new) forEvent: (Gauge12 new) withAverage: 0.9000.
	
	henry := Shooter newShooterFirstName: 'Henry' shoot: nil.
	henry middleName: 'John'; lastName: 'Duwe'.
	henry addConcurrent: TripleSubSeniorConcurrent new.
	henry setClass: (AClass new) forEvent: (Gauge12 new) withAverage: 0.9600.
	
	varney := Shooter newShooterFirstName: 'Jeff' shoot: nil.
	varney middleName: ''; lastName: 'Varney'.
	varney addConcurrent: TripleSubSeniorConcurrent new.
	varney setClass: (AAClass new) forEvent: (Gauge12 new) withAverage: 0.9600.
	
	jenny := Shooter newShooterFirstName: 'Jenny' shoot: nil.
	jenny middleName: ''; lastName: 'Notstad'.
	jenny addConcurrent: TripleSubSeniorConcurrent new.
	jenny addConcurrent: LadyConcurrent new.
	jenny setClass: (CClass new) forEvent: (Gauge12 new) withAverage: 0.9000.
	
	tom1 := Shooter newShooterFirstName: 'Tom' shoot: nil.
	tom1 middleName: ''; lastName: 'McDaniels'.
	tom1 addConcurrent: SeniorConcurrent new.
	tom1 setClass: (DClass new) forEvent: (Gauge12 new) withAverage: 0.8900.
	
	tom2 := Shooter newShooterFirstName: 'Tom' shoot: nil.
	tom2 middleName: ''; lastName: 'Steinbeck'.
	tom2 addConcurrent: SeniorConcurrent new.
	tom2 setClass: (BClass new) forEvent: (Gauge12 new) withAverage: 0.9100.
	
	tony := Shooter newShooterFirstName: 'Tony' shoot: nil.
	tony middleName: ''; lastName: 'Pavelka'.
	tony addConcurrent: SubSeniorConcurrent new.
	tony setClass: (EClass new) forEvent: (Gauge12 new) withAverage: 0.8500.
	
	randy := Shooter newShooterFirstName: 'Randy' shoot: nil.
	randy middleName: ''; lastName: 'Riehle'. 
	randy addConcurrent: SeniorConcurrent new.
	randy setClass: (AClass new) forEvent: (Gauge12 new) withAverage: 0.9650.

	paul := Shooter newShooterFirstName: 'Paul' shoot: nil.
	paul middleName: 'David'; lastName: 'Friesen'.
	paul addConcurrent: SeniorConcurrent new.
	paul setClass: (BClass new) forEvent: (Gauge12 new) withAverage: 0.9590.
	
	greg := Shooter newShooterFirstName: 'Greg' shoot: nil.
	greg middleName: ''; lastName: 'Schweppe'.
	greg addConcurrent: SeniorConcurrent new.
	greg setClass: (AClass new) forEvent: (Gauge12 new) withAverage: 0.9540.
	
	"Add them to Event"
	event12 addShooter: renk.
	event12 addShooter: henry.
	event12 addShooter: varney.
	event12 addShooter: jenny.
	event12 addShooter: tom1.
	event12 addShooter: tom2.
	event12 addShooter: tony.
	event12 addShooter: randy.
	event12 addShooter: paul.
	event12 addShooter: greg.
	
	
	"Print scores by class and concurrent"
	
	"Determine shootoffs"
	shootoffs12 := event12 shootoffs.
	
	self assert: (shootoffs12 size = 0).

	"Resolve ties"
	
	
	"Print winners"

! !

Object subclass: #ClassType
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ClassType commentStamp: '<historical>' prior: 0!
a class to hold class types.
!

ClassType subclass: #AAAClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

AAAClass class
	instanceVariableNames: 'uniqueInstance'!

AAAClass class
	instanceVariableNames: 'uniqueInstance'!

!AAAClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:38'!
new
     uniqueInstance ifNil: [uniqueInstance := self basicNew name:'AAAClass' ]. 
     ^ uniqueInstance.! !

!AAAClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:38'!
removeUnique
     
	uniqueInstance := nil.! !

!AAAClass methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:37'!
name: aString
	super name ifNil: [ super name: aString ].! !

ClassType subclass: #AAClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

AAClass class
	instanceVariableNames: 'uniqueInstance'!

AAClass class
	instanceVariableNames: 'uniqueInstance'!

!AAClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:38'!
new
     uniqueInstance ifNil: [uniqueInstance := self basicNew name:'AAClass' ]. 
     ^ uniqueInstance.! !

!AAClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:38'!
removeUnique
     
	uniqueInstance := nil.! !

!AAClass methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:37'!
name: aString
	super name ifNil: [ super name: aString ].! !

ClassType subclass: #AClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

AClass class
	instanceVariableNames: 'uniqueInstance'!

AClass class
	instanceVariableNames: 'uniqueInstance'!

!AClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:38'!
new
     uniqueInstance ifNil: [uniqueInstance := self basicNew name:'AClass' ]. 
     ^ uniqueInstance.! !

!AClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:38'!
removeUnique
     
	uniqueInstance := nil.! !

!AClass methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:37'!
name: aString
	super name ifNil: [ super name: aString ].! !

ClassType subclass: #BClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

BClass class
	instanceVariableNames: 'uniqueInstance'!

BClass class
	instanceVariableNames: 'uniqueInstance'!

!BClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:39'!
new
     uniqueInstance ifNil: [uniqueInstance := self basicNew name:'BClass' ]. 
     ^ uniqueInstance.! !

!BClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:39'!
removeUnique
     
	uniqueInstance := nil.! !

!BClass methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:37'!
name: aString
	super name ifNil: [ super name: aString ].! !

ClassType subclass: #CClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

CClass class
	instanceVariableNames: 'uniqueInstance'!

CClass class
	instanceVariableNames: 'uniqueInstance'!

!CClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:39'!
new
     uniqueInstance ifNil: [uniqueInstance := self basicNew name:'CClass' ]. 
     ^ uniqueInstance.! !

!CClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:39'!
removeUnique
     
	uniqueInstance := nil.! !

!CClass methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:37'!
name: aString
	super name ifNil: [ super name: aString ].! !

!ClassType class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/30/2013 09:46'!
newFromAverage: anAverage forEventType: anEventType 
	^ AAClass new.! !

!ClassType methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 15:59'!
<= aClassType 
	^ self name <= aClassType name.! !

!ClassType methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:07'!
name
	^ name.! !

!ClassType methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 17:43'!
name: aString
	name := aString.! !

!ClassType methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 17:38'!
printOn: aStream
	aStream nextPutAll: self name.! !

ClassType subclass: #DClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

DClass class
	instanceVariableNames: 'uniqueInstance'!

DClass class
	instanceVariableNames: 'uniqueInstance'!

!DClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 19:11'!
new
     uniqueInstance ifNil: [uniqueInstance := self basicNew name:'DClass' ]. 
     ^ uniqueInstance.! !

!DClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:39'!
removeUnique
     
	uniqueInstance := nil.! !

!DClass methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:37'!
name: aString
	super name ifNil: [ super name: aString ].! !

ClassType subclass: #EClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

EClass class
	instanceVariableNames: 'uniqueInstance'!

EClass class
	instanceVariableNames: 'uniqueInstance'!

!EClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:39'!
new
     uniqueInstance ifNil: [uniqueInstance := self basicNew name:'EClass' ]. 
     ^ uniqueInstance.! !

!EClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:39'!
removeUnique
     
	uniqueInstance := nil.! !

!EClass methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:37'!
name: aString
	super name ifNil: [ super name: aString ].! !

ClassType subclass: #NCClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

NCClass class
	instanceVariableNames: 'uniqueInstance'!

NCClass class
	instanceVariableNames: 'uniqueInstance'!

!NCClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:39'!
new
     uniqueInstance ifNil: [uniqueInstance := self basicNew name:'NCClass' ]. 
     ^ uniqueInstance.! !

!NCClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:58'!
removeUnique
     
	uniqueInstance := nil.! !

!NCClass methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:37'!
name: aString
	super name ifNil: [ super name: aString ].! !

ClassType subclass: #OverallClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

OverallClass class
	instanceVariableNames: 'uniqueInstance'!

OverallClass class
	instanceVariableNames: 'uniqueInstance'!

!OverallClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
new
     uniqueInstance ifNil: [uniqueInstance := self basicNew name:'Overall' ]. 
     ^ uniqueInstance.! !

!OverallClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
removeUnique
     
	uniqueInstance := nil.! !

!OverallClass methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:36'!
name: aString
	super name ifNil: [ super name: aString ].! !

Object subclass: #ConcurrentType
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

ConcurrentType subclass: #ActiveMillitaryConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

ActiveMillitaryConcurrent class
	instanceVariableNames: 'uniqueInstance'!

ActiveMillitaryConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!ActiveMillitaryConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'ActiveMillitaryConcurrent']. 
     ^ uniqueInstance.! !

!ActiveMillitaryConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
removeUnique
     
	uniqueInstance := nil.! !

!ActiveMillitaryConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:34'!
name: aString
	super name ifNil: [ super name: aString ].! !

ConcurrentType subclass: #CollegiateConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

CollegiateConcurrent class
	instanceVariableNames: 'uniqueInstance'!

CollegiateConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!CollegiateConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'CollegiateConcurrent']. 
     ^ uniqueInstance.! !

!CollegiateConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
removeUnique
     
	uniqueInstance := nil.! !

!CollegiateConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:34'!
name: aString
	super name ifNil: [ super name: aString ].! !

!ConcurrentType methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 15:59'!
<= aConcurrentType 
	^self name <= aConcurrentType name.! !

!ConcurrentType methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:59'!
name
	^ name.! !

!ConcurrentType methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 17:44'!
name: aString
	name := aString.! !

!ConcurrentType methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 17:38'!
printOn: aStream
	aStream nextPutAll: self name.! !

ConcurrentType subclass: #JuniorConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

JuniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

JuniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!JuniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'JuniorConcurrent']. 
     ^ uniqueInstance.! !

!JuniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
removeUnique
     
	uniqueInstance := nil.! !

!JuniorConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:34'!
name: aString
	super name ifNil: [ super name: aString ].! !

ConcurrentType subclass: #LadyConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

LadyConcurrent class
	instanceVariableNames: 'uniqueInstance'!

LadyConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!LadyConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'LadyConcurrent']. 
     ^ uniqueInstance.! !

!LadyConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
removeUnique
     
	uniqueInstance := nil.! !

!LadyConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:34'!
name: aString
	super name ifNil: [ super name: aString ].! !

ConcurrentType subclass: #RetiredMillitaryConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

RetiredMillitaryConcurrent class
	instanceVariableNames: 'uniqueInstance'!

RetiredMillitaryConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!RetiredMillitaryConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'RetiredMillitaryConcurrent']. 
     ^ uniqueInstance.! !

!RetiredMillitaryConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
removeUnique
     
	uniqueInstance := nil.! !

!RetiredMillitaryConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:34'!
name: aString
	super name ifNil: [ super name: aString ].! !

ConcurrentType subclass: #SeniorConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

SeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

SeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!SeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'SeniorConcurrent']. 
     ^ uniqueInstance.! !

!SeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
removeUnique
     
	uniqueInstance := nil.! !

!SeniorConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:34'!
name: aString
	super name ifNil: [ super name: aString ].! !

ConcurrentType subclass: #SubJuniorConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

SubJuniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

SubJuniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!SubJuniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'SubJuniorConcurrent']. 
     ^ uniqueInstance.! !

!SubJuniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
removeUnique
     
	uniqueInstance := nil.! !

!SubJuniorConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:34'!
name: aString
	super name ifNil: [ super name: aString ].! !

ConcurrentType subclass: #SubSeniorConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

SubSeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

SubSeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!SubSeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'SubSeniorConcurrent']. 
     ^ uniqueInstance.! !

!SubSeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
removeUnique
     
	uniqueInstance := nil.! !

!SubSeniorConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:34'!
name: aString
	super name ifNil: [ super name: aString ].! !

ConcurrentType subclass: #SubSubSeniorConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

SubSubSeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

SubSubSeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!SubSubSeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'SubSubSeniorConcurrent']. 
     ^ uniqueInstance.! !

!SubSubSeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
removeUnique
     
	uniqueInstance := nil.! !

!SubSubSeniorConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:33'!
name: aString
	super name ifNil: [ super name: aString ].! !

ConcurrentType subclass: #TripleSubSeniorConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

TripleSubSeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

TripleSubSeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!TripleSubSeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:42'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'TripleSubSeniorConcurrent']. 
     ^ uniqueInstance.! !

!TripleSubSeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:42'!
removeUnique
     
	uniqueInstance := nil.! !

!TripleSubSeniorConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:33'!
name: aString
	super name ifNil: [ super name: aString ].! !

ConcurrentType subclass: #VeteranConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

VeteranConcurrent class
	instanceVariableNames: 'uniqueInstance'!

VeteranConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!VeteranConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:42'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'VeteranConcurrent']. 
     ^ uniqueInstance.! !

!VeteranConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:42'!
removeUnique
     
	uniqueInstance := nil.! !

!VeteranConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:33'!
name: aString
	super name ifNil: [ super name: aString ].! !

Object subclass: #Database
	instanceVariableNames: 'shoots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Object subclass: #Event
	instanceVariableNames: 'name shooters eventType scores scoreFormat honors shootoffs shoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Event subclass: #CompositeEvent
	instanceVariableNames: 'events shoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

CompositeEvent class
	instanceVariableNames: 'events'!

CompositeEvent class
	instanceVariableNames: 'events'!

!CompositeEvent class methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/29/2013 18:20'!
newEventWithName: aString 
	^(self new) eventWithName: aString.! !

!CompositeEvent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 18:58'!
newEventWithName: aString andEvents: aCollection
	^(self new) eventWithName: aString andEvents: aCollection.! !

!CompositeEvent methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/29/2013 18:28'!
addEvent: anEvent
	(events includes: anEvent)
		ifFalse: [ events add: anEvent ]! !

!CompositeEvent methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/24/2013 16:40'!
enteredEvent: anEvent 
	^events includes: anEvent.! !

!CompositeEvent methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/29/2013 18:07'!
eventWithName: aName 
	super eventWithName: aName andType: nil.
	events := OrderedCollection new.
	
	! !

!CompositeEvent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 19:00'!
eventWithName: aName andEvents: aCollection
	self eventWithName: aName.
	self events: aCollection.
	
	! !

!CompositeEvent methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/24/2013 14:10'!
events
	^events.! !

!CompositeEvent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 06:29'!
events: aCollection
	events := aCollection.! !

!CompositeEvent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/23/2013 10:58'!
getMaxTotalScore
	" return a collection of zeros that is the same length as the score format"
	|maxscore|
	maxscore := 0.
	maxscore := events inject:  maxscore into: [ :total :event | total + (event getMaxTotalScore)].
	^ maxscore.
! !

!CompositeEvent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/23/2013 10:57'!
getTotalScoreFor: aShooter
	^ events inject: 0 into: [:sum :event | sum + (event getTotalScoreFor: aShooter)].! !

!CompositeEvent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/23/2013 10:59'!
getZeroScore
	" return a collection of zeros that is the same length as the score format"
	|zeroscore|
	zeroscore := OrderedCollection new.
	events do: [ :event | zeroscore add: 0].
	
	^ zeroscore.
	! !

!CompositeEvent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 19:17'!
remove: anEvent
	events remove: anEvent.! !

!CompositeEvent methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/24/2013 14:06'!
shoot
   ^shoot.! !

!CompositeEvent methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/24/2013 13:37'!
shoot: aShoot
	shoot := aShoot.! !

!Event class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 18:02'!
newEventWithName: aName
	^ self new eventWithName: aName.! !

!Event class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 16:23'!
newEventWithName: aName andType: aType
	^ self new eventWithName: aName andType: aType.! !

!Event class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/30/2013 09:31'!
newEventWithName: aName andType: aType withScoreFormat: aScoreFormat
	^ self new eventWithName: aName andType: aType withScoreFormat: aScoreFormat.! !

!Event class methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/24/2013 16:29'!
newEventWithName: aName shoot: aShoot
	| anEvent |
	anEvent := self new.
	anEvent name: aName; shoot: aShoot.
	^anEvent.! !

!Event methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/24/2013 17:24'!
addCompositeEvent: aCompositeEvent
	"compositeEvent add: aCompositeEvent."
	"scores at: aCompositeEvent  put: (self getZeroScore)."
	aCompositeEvent  addEvent: self.
	
	 ! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 05:57'!
addShooter: aShooter
	shooters add: aShooter.
	scores at: aShooter put: (self getZeroScore).
	aShooter addEvent: self.
	
	 ! !

!Event methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/24/2013 13:25'!
compositeEvent
	^compositeEvent.! !

!Event methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/24/2013 17:22'!
compositeEvents
	^compositeEvents.! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:23'!
createHonors
	self createHonorsFor: 1.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/30/2013 10:10'!
createHonorsFor: aNumber
	"Creates the list of Honor objects given how many places will exist. This can be done once all shooters have been entered for an Event, but before all scores are entered for the event."

	| allClasses allConcurrents concurrents tempHonor tempShooters sortedShooters rankings rank tempCollection previousScore tempScore |
	allClasses := OrderedCollection new.
	allConcurrents := OrderedCollection new.
	tempHonor := Honor new.
	shootoffs := Dictionary new.	"Have to reset when updating..."
	honors := OrderedCollection new.	"Have to reset when updating..."	"find all present classes and concurrents among shooters"
	shooters
		do: [ :shooter | 
			allClasses addIfNotPresent: (shooter classFor: ((self class = CompositeEvent) ifFalse: [self eventType] ifTrue: [Bore410 new])).	"FIXME: Need to not use event type for Composite Events -- should be able to make generic"
			concurrents := shooter concurrents.
			concurrents do: [ :concurrent | allConcurrents addIfNotPresent: concurrent ] ].	"add an overall honor with all shooters"
	shooters size > 0
		ifTrue: [ 
			allClasses := allClasses asSortedCollection.
			concurrents := concurrents asSortedCollection.
			tempHonor := Honor newForEvent: self type: OverallClass new numPositions: aNumber.
			tempHonor addShooters: shooters.
			honors add: tempHonor	"for each class create a list of shooters and construct an honor for it" ].
	allClasses
		do: [ :class | 
			tempShooters := shooters select: [ :shooter | (shooter classFor: ((self class = CompositeEvent) ifFalse: [self eventType] ifTrue: [Bore410 new])) = class ].
			tempHonor := Honor newForEvent: self type: class numPositions: aNumber.
			tempHonor addShooters: tempShooters.
			honors add: tempHonor ].	"for each concurrent create a list of shooters and construct an honor for it"
	allConcurrents
		do: [ :concurrent | 
			tempShooters := shooters select: [ :shooter | shooter concurrents includes: concurrent ].
			tempHonor := Honor newForEvent: self type: concurrent numPositions: aNumber.
			tempHonor addShooters: tempShooters.
			honors add: tempHonor ].	" now generate the rankings for each honor"
	honors
		do: [ :honor | 
			sortedShooters := honor shooters asSortedCollection: [ :x :y | (self getTotalScoreFor: x) > (self getTotalScoreFor: y) ].
			rankings := Dictionary new.
			rank := 1.
			tempCollection := OrderedCollection new.
			rankings at: rank put: tempCollection.
			previousScore := self getMaxTotalScore + 1.
			sortedShooters
				do: [ :each | 
					tempScore := self getTotalScoreFor: each.
					tempScore = previousScore
						ifTrue: [ tempCollection add: each ]
						ifFalse: [ 
							tempCollection := OrderedCollection new.
							rankings at: rank put: tempCollection.
							rank := rank + 1.
							tempCollection add: each.
							previousScore := tempScore ] ].
			honor rankings: rankings.
			shootoffs at: honor put: OrderedCollection new ]! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 16:24'!
eventType 
	^eventType.! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 13:18'!
eventType: aType
	eventType := aType.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/23/2013 10:52'!
eventWithName: aName 
	self eventWithName: aName andType: (Gauge12 new).
	
	! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/23/2013 08:39'!
eventWithName: aName andType: aType
	name:= aName.
	shooters := OrderedCollection new.
	scores := Dictionary new. "key is the name of a shooter. Value is a collection of scores."
	scoreFormat := OrderedCollection new.
	scoreFormat add: 25; add: 25; add: 25 ; add: 25. "this is just a collection. Length of the collection specifies the number of rounds. Value of each element is the maximum score that can be entered for each round"
	shootoffs  := Dictionary new.
	honors := OrderedCollection new.
	eventType := aType.
	
	! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/23/2013 10:54'!
eventWithName: aName andType: aType withScoreFormat: aScoreFormat
	name:= aName.
	shooters := OrderedCollection new.
	scores := Dictionary new. "key is the name of a shooter. Value is a collection of scores."
	scoreFormat := aScoreFormat. "this is just a collection. Length of the collection specifies the number of rounds. Value of each element is the maximum score that can be entered for each round"
	shootoffs  := Dictionary new.
	honors := OrderedCollection new.
	eventType := aType.
	
	! !

!Event methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/24/2013 14:09'!
events
	^events.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/23/2013 07:18'!
generateHonors
	"I attempt to assign the winner of each already created honor. If there are ties, I generate shootoffs."
	self generateHonors: 1.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 13:36'!
generateHonors: aNumber
	"I attempt to assign the winner of each already created honor. If there are ties, I generate shootoffs."

	| tempCollection sizeoftemp total |

	
	honors
		do: [ :honor | 
			total := 0.
			1 to: aNumber do: [ :i | 
				tempCollection := honor rankings at: i.
				sizeoftemp := tempCollection size.
				sizeoftemp > 1 & (total < aNumber)
					ifTrue: [ 
						self generateShootOffFor: honor withRank: i between: tempCollection.
						total := total + sizeoftemp ]
					ifFalse: [ total := total + 1 ]. ].
				honor setWinners.
				].
			
		
	! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/23/2013 10:18'!
generateShootOffFor: anHonor withRank: aRank between: someShooters
	"Generates a single shootoff for a particular honor between a collection of shooters. It adds the shootoff to the Event's Collection of shootoffs. "
	| tmpShootoff |
	tmpShootoff := Shootoff newWithHonor: anHonor withRank: aRank andShooters: someShooters.
	(shootoffs at: anHonor) add: tmpShootoff.
	 
	! !

!Event methodsFor: 'helper methods' stamp: 'HenryDuwe 7/9/2013 19:29'!
getMaxTotalScore
	" return a collection of zeros that is the same length as the score format"
	|maxscore|
	maxscore := 0.
	maxscore := scoreFormat inject:  maxscore into: [ :total :score | total + score].
	^ maxscore.
	! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 07:41'!
getScoreFor: aShooter
	^ scores at: aShooter ifAbsent: [ ShooterNotFoundError signal ] .! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 08:47'!
getTotalScoreFor: aShooter
	^ ((scores at: aShooter ifAbsent: [ ShooterNotFoundError signal ] ) sum) asNumber.! !

!Event methodsFor: 'helper methods' stamp: 'HenryDuwe 7/9/2013 16:16'!
getZeroScore
	" return a collection of zeros that is the same length as the score format"
	|zeroscore|
	zeroscore := OrderedCollection new.
	scoreFormat do: [ :score | zeroscore add: 0].
	
	^ zeroscore.
	! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:27'!
honors 
	^honors.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 16:23'!
honorsDo: aBlock
	honors do: [ :eachHonor | aBlock value: eachHonor ]! !

!Event methodsFor: 'helper methods' stamp: 'HenryDuwe 7/30/2013 09:35'!
isScoreValid: aScore
	|bool|
	bool := true.
	( aScore size == scoreFormat size ) ifFalse:  [bool := false] ifTrue: [
		aScore with: scoreFormat do: [:score :bound | (score > bound) ifTrue: [bool:= false]]
		].
	
	

	^bool! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:22'!
name 
	^name.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:30'!
name: aName
	name := aName.! !

!Event methodsFor: 'helper methods' stamp: 'HenryDuwe 7/23/2013 11:45'!
numShootoffs
	^ (shootoffs associations) inject: 0 into: [ :sum :nextHonorAss | sum + (nextHonorAss value size) ].! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 16:31'!
printOn: aStream
	aStream nextPutAll: (self name).! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 16:15'!
removeNC
	"process all NC class shooters and put them in appropriate class"
	.! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 16:10'!
removeShooter: aShooter
	shooters remove:  aShooter.
	scores remove:  (aShooter name) .
	
	 ! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/30/2013 09:31'!
scoreFormat
	^scoreFormat.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/30/2013 09:32'!
scoreFormat: aScoreFormat
	scoreFormat := aScoreFormat.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/30/2013 09:47'!
setScore: aScore for: aShooter
	(self isScoreValid: aScore)
		ifTrue: [ 
			scores at: aShooter put: aScore.
			(aShooter classFor: eventType) = NCClass new
				ifTrue: [ 
					aShooter setAverage: (self getTotalScoreFor: aShooter) / 100 forEvent: eventType.
					aShooter setClass: (ClassType newFromAverage: (aShooter averageFor: eventType) forEventType: eventType) forEvent: eventType] ]
		ifFalse: [ ScoreFormatError signal ]! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 08:14'!
setScores: aDictionary
	scores := aDictionary.! !

!Event methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/24/2013 14:07'!
shoot
	^shoot.! !

!Event methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/24/2013 14:07'!
shoot: aShoot
	shoot := aShoot.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:22'!
shooters
	^shooters.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:27'!
shootoffs
	^shootoffs.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/30/2013 00:25'!
shootoffsAnySatisfy: aBlock
	^shootoffs values inject: false into: [ :satisfied :shootoffsOC | satisfied or: (shootoffsOC anySatisfy: [ :shootoff | aBlock value: shootoff ]) ].
	! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 15:44'!
shootoffsDo: aBlock
	honors do: [ :eachHonor | (shootoffs at: eachHonor) do: aBlock ]! !

Event subclass: #RealEvent
	instanceVariableNames: 'eventType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Object subclass: #EventType
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

EventType subclass: #Bore410
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Bore410 class
	instanceVariableNames: 'uniqueInstance'!

Bore410 class
	instanceVariableNames: 'uniqueInstance'!

!Bore410 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:33'!
new 
	uniqueInstance ifNil: [
		uniqueInstance := self basicNew name:'Bore410']. 
     ^ uniqueInstance.! !

!Bore410 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:29'!
removeUnique
     
	uniqueInstance := nil.! !

!Bore410 methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:29'!
name: aString
	super name ifNil: [ super name: aString ].! !

EventType subclass: #Doubles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Doubles class
	instanceVariableNames: 'uniqueInstance'!

Doubles class
	instanceVariableNames: 'uniqueInstance'!

!Doubles class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:31'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'Doubles']. 
     ^ uniqueInstance.! !

!Doubles class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:29'!
removeUnique
     
	uniqueInstance := nil.! !

!Doubles methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:29'!
name: aString
	super name ifNil: [ super name: aString ].! !

!EventType methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:22'!
name
	^name.! !

!EventType methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 17:44'!
name: aString
	name := aString.! !

!EventType methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 17:38'!
printOn: aStream
	aStream nextPutAll: self name.! !

EventType subclass: #Gauge12
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Gauge12 class
	instanceVariableNames: 'uniqueInstance'!

Gauge12 class
	instanceVariableNames: 'uniqueInstance'!

!Gauge12 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:31'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name: 'Gauge12']. 
     ^ uniqueInstance.! !

!Gauge12 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:18'!
removeUnique
     
	uniqueInstance := nil.! !

!Gauge12 methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:23'!
name: aString
	super name ifNil: [ super name: aString ].! !

EventType subclass: #Gauge20
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Gauge20 class
	instanceVariableNames: 'uniqueInstance'!

Gauge20 class
	instanceVariableNames: 'uniqueInstance'!

!Gauge20 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:30'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'Gauge20']. 
     ^ uniqueInstance.! !

!Gauge20 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:29'!
removeUnique
     
	uniqueInstance := nil.! !

!Gauge20 methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:28'!
name: aString
	super name ifNil: [ super name: aString ].! !

EventType subclass: #Gauge28
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Gauge28 class
	instanceVariableNames: 'uniqueInstance'!

Gauge28 class
	instanceVariableNames: 'uniqueInstance'!

!Gauge28 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:31'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'Gauge28']. 
     ^ uniqueInstance.! !

!Gauge28 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:30'!
removeUnique
     
	uniqueInstance := nil.! !

!Gauge28 methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:29'!
name: aString
	super name ifNil: [ super name: aString ].! !

Object subclass: #Honor
	instanceVariableNames: 'event type shooters numPositions winners rankings resolved losers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!Honor class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/7/2013 14:36'!
newForEvent: anEvent type: aType numPositions: aNumber 	
	^ self new event: anEvent type: aType numPositions: aNumber 	 ! !

!Honor methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/7/2013 14:47'!
addShooters: aCollection
	aCollection do: [ :shooter |
		shooters addIfNotPresent: shooter.
		 ].! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/30/2013 00:33'!
clearResolved
	resolved := false.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:48'!
event
	^event.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/30/2013 00:51'!
event: anEvent type: aType numPositions: aNumber
	event := anEvent.
	type := aType.
	numPositions := aNumber.
	shooters := OrderedCollection new.
	winners := OrderedCollection new.
	losers := Dictionary new.
	rankings := Dictionary new.
	resolved := false.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/30/2013 00:36'!
isResolved
	^resolved.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 19:02'!
numPositions 
	^numPositions.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 17:37'!
printOn: aStream
	event printOn: aStream.
	aStream nextPutAll: ': '.
	type printOn: aStream.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/30/2013 00:51'!
rankings
	self isResolved
		ifFalse: [ ^ rankings ]
		ifTrue: [ ^ losers ]! !

!Honor methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/7/2013 16:35'!
rankings: aDictionary 
	rankings := aDictionary .! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/23/2013 10:21'!
resolved
	^resolved.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/30/2013 09:03'!
setWinners
	| isResolved tmpOC |
	isResolved := true.
	isResolved := (event shootoffs at: self)
		inject: isResolved
		into: [ :nowResolved :shootoff | nowResolved and: shootoff resolved ].
	isResolved
		ifTrue: [ 
			winners := OrderedCollection new.
			losers := Dictionary new.
			rankings
				associationsDo: [ :rankAss | 
					tmpOC := OrderedCollection new.
					losers at: rankAss put: tmpOC.
					rankAss value
						do: [ :nextBestShooter | 
							winners size < numPositions
								ifTrue: [ winners add: nextBestShooter ]
								ifFalse: [ tmpOC add: nextBestShooter ] ] ] ].
	resolved := isResolved! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/23/2013 10:08'!
setWinners: someShooters forRank: aRank
	rankings at: aRank put: someShooters.
	self setWinners.
! !

!Honor methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/7/2013 16:00'!
shooters
	^shooters.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:48'!
type 
	^type.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:49'!
winners 
	^winners.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/7/2013 16:10'!
winners: aList 
	winners := aList.! !

Object subclass: #Shooter
	instanceVariableNames: 'uuid firstName lastName middleName dob membershipNumber classifications averages concurrents address phone email shoot events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!Shooter class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 05:48'!
newShooterFirstName: first shoot: aShoot
	| aShooter |
	aShooter := self new.
	aShooter firstName: first; shoot: aShoot.
	^aShooter.! !

!Shooter methodsFor: 'concurrent related' stamp: 'HenryDuwe 7/9/2013 18:51'!
addConcurrent: aConcurrent 
	concurrents add: aConcurrent.
! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 05:44'!
addEvent: anEvent 
	events add: anEvent.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:14'!
address
	^ address.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 19:01'!
address: anAddress 
	 address := anAddress.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/8/2013 14:09'!
averageFor: anEventType
	^  averages at: anEventType.! !

!Shooter methodsFor: 'concurrent related' stamp: 'HenryDuwe 7/9/2013 18:53'!
belongsToConcurrent: aConcurrent 
	concurrents indexOf: aConcurrent ifAbsent: [^ false].
	^true.
! !

!Shooter methodsFor: 'class related' stamp: 'BiplabDeka 7/8/2013 14:10'!
classFor: anEventType
	^ classifications at:anEventType .! !

!Shooter methodsFor: 'class related' stamp: 'BiplabDeka 7/5/2013 16:27'!
concurrents
^ concurrents .! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:53'!
dob
	^dob.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:34'!
dob: aDate  	
	dob := aDate.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:14'!
email  
	^ email.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 19:00'!
email: anEmail   
	email := anEmail.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/24/2013 16:59'!
enteredEvent: anEvent 
	^events includes: anEvent. ! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 05:44'!
events
	^events.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:56'!
firstName
	^firstName.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 05:46'!
firstName: first 
	|allTypes|
	firstName:= first.
	middleName:= '' .
	lastName:= ''.
	dob:= Date newDay: 1 month:1  year:1900.
	address:='your address'.
	membershipNumber:='0AB123'.
	uuid:= firstName,'_',middleName,'_',lastName.
	phone := 1112223333.
	email := 'yourname@example.com'.
	
	classifications := Dictionary new. " key is event type. value is a Class type."
	averages := Dictionary new. " key is event type. value is a number."	
	allTypes := EventType allSubclasses.
	allTypes do: [ :type |
		classifications at: (type new) put: (NCClass new) .
		averages at: (type new) put: 0.
		 ].
	
	concurrents := OrderedCollection new. "list of concurrent objects stored as names"
	events := OrderedCollection new. "list of Events in which I am participating."
	
	

	 ! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/8/2013 14:10'!
getClass: anEventType 
	" return a class is event is present. else return a NC with avergae zero"
	^ classifications at: (anEventType) ifAbsent: (ClassType newNCClass: 0) .! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:56'!
lastName
	^lastName.! !

!Shooter methodsFor: 'class related' stamp: 'BiplabDeka 7/15/2013 14:24'!
lastName: name 
	lastName:= name .
	uuid:= firstName,'_',middleName,'_',lastName.
	! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:55'!
membershipNumber	
	^ membershipNumber .! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:35'!
membershipNumber: aNumber  	
	membershipNumber := aNumber.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:55'!
middleName
	^middleName.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 14:23'!
middleName: name 
	middleName:= name .
	uuid:= firstName,'_',middleName,'_',lastName.
	! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 17:36'!
name
	^ firstName,' ',middleName,' ',lastName.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:14'!
phone 
	^ phone.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 19:00'!
phone: number 
	phone := number.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 17:11'!
printOn: aStream 
	aStream nextPutAll: (self name).! !

!Shooter methodsFor: 'class related' stamp: 'HenryDuwe 7/15/2013 18:07'!
setAverage: anAverage forEvent: anEventType
	
	
	averages at: (anEventType ) put: anAverage.! !

!Shooter methodsFor: 'class related' stamp: 'HenryDuwe 7/15/2013 18:06'!
setClass: aClass forEvent: anEventType 
	
	classifications at: (anEventType ) put: (aClass) .
	! !

!Shooter methodsFor: 'class related' stamp: 'BiplabDeka 7/8/2013 14:34'!
setClass: aClass forEvent: anEventType withAverage: anAverage
	
	classifications at: (anEventType ) put: (aClass) .
	averages at: (anEventType ) put: anAverage.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 05:43'!
shoot
	^shoot.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 05:43'!
shoot: aShoot
	shoot := aShoot.! !

Object subclass: #Shootoff
	instanceVariableNames: 'shooters resolved honor rank'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!Shootoff class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/23/2013 08:31'!
newWithHonor: anHonor andShooters: someShooters 
	^(self new) honor: anHonor; shooters: someShooters.! !

!Shootoff class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/23/2013 08:44'!
newWithHonor: anHonor withRank: aRank andShooters: someShooters 
	^(self new) honor: anHonor; rank: aRank; shooters: someShooters.! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/30/2013 00:32'!
clearResolved
	resolved := false.
	honor clearResolved.! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:40'!
honor 
	^honor.! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/23/2013 08:32'!
honor: anHonor
	honor := anHonor.! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/23/2013 08:31'!
initialize 
	resolved := false.! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/29/2013 14:18'!
isResolved
	^resolved.! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/23/2013 08:43'!
rank
	^rank.! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/23/2013 08:43'!
rank: aRank
	rank := aRank.! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:40'!
resolved
	^resolved.! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/30/2013 08:29'!
resolvedWith:  someShooters
	"maybe add a check that someShooters contain the same shooters as shooters originally did..." 
	shooters := someShooters.
	resolved := true.
	honor setWinners: (OrderedCollection newFrom: shooters) forRank: rank.
	^true.! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:40'!
shooters
	^shooters.! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/23/2013 08:32'!
shooters: someShooters
	shooters := someShooters.! !

Object subclass: #SkeetManagerInit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!SkeetManagerInit class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/24/2013 14:17'!
initialize 
	MyFileLibrary addAllFilesIn: 'include/'.
	ZnZincServerAdaptor startOn: 8080.
	ViewMain new.
	ViewMain initialize.
	Shoot warmUp.! !

Object subclass: #SkeetManagerInstall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!SkeetManagerInstall class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/24/2013 13:56'!
initialize
	Gofer new
		squeaksource: 'SandstoneDb';
		package: 'SandstoneDb';
		load.
	Gofer new
		squeaksource: 'MetacelloRepository';
		package: 'ConfigurationOfSeaside30';
		load.
	(Smalltalk at: #ConfigurationOfSeaside30) load.
! !
SkeetManagerInstall initialize!
ViewMain initialize!
SkeetManagerInit initialize!
